Attribute VB_Name = "mTranslation"
Public Enum DEVICE_TYPE
   FILE_DEVICE_CD_ROM = &H2
   FILE_DEVICE_TAPE = &H1F
   FILE_DEVICE_VIRTUAL_DISK = &H24
   FILE_DEVICE_CHANGER = &H30
   FILE_DEVICE_SMARTCARD = &H31
   FILE_DEVICE_ACPI = &H32
   FILE_DEVICE_DVD = &H33
End Enum

Public Enum STORAGE_BUS_TYPE
   BusTypeUnknown = 0
   BusTypeScsi = 1
   BusTypeAtapi = 2
   BusTypeAta = 3
   BusType1394 = 4
   BusTypeSsa = 5
   BusTypeFibre = 6
   BusTypeUsb = 7
   BusTypeRAID = 8
   BusTypeMaxReserved = &H7F&
End Enum

Public Enum LOADING_MECHANIZM_TYPE
   lmCaddy = 0
   lmTray = 1
   lmPopup = 2
   lmChangerIndividual = 4
   lmChangerMagazine = 5
End Enum

Public Enum STORAGE_MEDIA_TYPE
    DDS_4mm = &H20            ' Tape - DAT DDS1,2,... (all vendors)
    MiniQic                   ' Tape - miniQIC Tape
    Travan                    ' Tape - Travan TR-1,2,3,...
    QIC                       ' Tape - QIC
    MP_8mm                    ' Tape - 8mm Exabyte Metal Particle
    AME_8mm                   ' Tape - 8mm Exabyte Advanced Metal Evap
    AIT1_8mm                  ' Tape - 8mm Sony AIT
    DLT                       ' Tape - DLT Compact IIIxt, IV
    NCTP                      ' Tape - Philips NCTP
    IBM_3480                  ' Tape - IBM 3480
    IBM_3490E                 ' Tape - IBM 3490E
    IBM_Magstar_3590          ' Tape - IBM Magstar 3590
    IBM_Magstar_MP            ' Tape - IBM Magstar MP
    STK_DATA_D3               ' Tape - STK Data D3
    SONY_DTF                  ' Tape - Sony DTF
    DV_6mm                    ' Tape - 6mm Digital Video
    DMI                       ' Tape - Exabyte DMI and compatibles
    SONY_D2                   ' Tape - Sony D2S and D2L
    CLEANER_CARTRIDGE         ' Cleaner - All Drive types that support Drive Cleaners
    CD_ROM                    ' Opt_Disk - CD
    CD_R                      ' Opt_Disk - CD-Recordable (Write Once)
    CD_RW                     ' Opt_Disk - CD-Rewriteable
    DVD_ROM                   ' Opt_Disk - DVD-ROM
    DVD_R                     ' Opt_Disk - DVD-Recordable (Write Once)
    DVD_RW                    ' Opt_Disk - DVD-Rewriteable
    MO_3_RW                   ' Opt_Disk - 3.5" Rewriteable MO Disk
    MO_5_WO                   ' Opt_Disk - MO 5.25" Write Once
    MO_5_RW                   ' Opt_Disk - MO 5.25" Rewriteable (not LIMDOW)
    MO_5_LIMDOW               ' Opt_Disk - MO 5.25" Rewriteable (LIMDOW)
    PC_5_WO                   ' Opt_Disk - Phase Change 5.25" Write Once Optical
    PC_5_RW                   ' Opt_Disk - Phase Change 5.25" Rewriteable
    PD_5_RW                   ' Opt_Disk - PhaseChange Dual Rewriteable
    ABL_5_WO                  ' Opt_Disk - Ablative 5.25" Write Once Optical
    PINNACLE_APEX_5_RW        ' Opt_Disk - Pinnacle Apex 4.6GB Rewriteable Optical
    SONY_12_WO                ' Opt_Disk - Sony 12" Write Once
    PHILIPS_12_WO             ' Opt_Disk - Philips/LMS 12" Write Once
    HITACHI_12_WO             ' Opt_Disk - Hitachi 12" Write Once
    CYGNET_12_WO              ' Opt_Disk - Cygnet/ATG 12" Write Once
    KODAK_14_WO               ' Opt_Disk - Kodak 14" Write Once
    MO_NFR_525                ' Opt_Disk - Near Field Recording (Terastor)
    NIKON_12_RW               ' Opt_Disk - Nikon 12" Rewriteable
    IOMEGA_ZIP                ' Mag_Disk - Iomega Zip
    IOMEGA_JAZ                ' Mag_Disk - Iomega Jaz
    SYQUEST_EZ135             ' Mag_Disk - Syquest EZ135
    SYQUEST_EZFLYER           ' Mag_Disk - Syquest EzFlyer
    SYQUEST_SYJET             ' Mag_Disk - Syquest SyJet
    AVATAR_F2                 ' Mag_Disk - 2.5" Floppy
    MP2_8mm                   ' Tape - 8mm Hitachi
    DST_S                     ' Ampex DST Small Tapes
    DST_M                     ' Ampex DST Medium Tapes
    DST_L                     ' Ampex DST Large Tapes
    VXATape_1                 ' Ecrix 8mm Tape
    VXATape_2                 ' Ecrix 8mm Tape
    STK_9840                  ' STK 9840
    LTO_Ultrium               ' IBM, HP, Seagate LTO Ultrium
    LTO_Accelis               ' IBM, HP, Seagate LTO Accelis
    DVD_RAM                   ' Opt_Disk - DVD-RAM
    AIT_8mm                   ' AIT2 or higher
    ADR_1                     ' OnStream ADR Mediatypes
    ADR_2
End Enum

Public Function TranslateDeviceType(ByVal DevType As DEVICE_TYPE) As String
   Select Case DevType
      Case FILE_DEVICE_CD_ROM:       TranslateDeviceType = "Compact Disk (CD)"
      Case FILE_DEVICE_TAPE:         TranslateDeviceType = "TAPE"
      Case FILE_DEVICE_VIRTUAL_DISK: TranslateDeviceType = "VIRTUAL DISK"
      Case FILE_DEVICE_CHANGER:      TranslateDeviceType = "CHANGER"
      Case FILE_DEVICE_SMARTCARD:    TranslateDeviceType = "SMARTCARD"
      Case FILE_DEVICE_ACPI:         TranslateDeviceType = "ACPI DEVICE"
      Case FILE_DEVICE_DVD:          TranslateDeviceType = "Digital Video Disc (DVD)"
   End Select
End Function

Public Function TranslateBusType(ByVal BusType As STORAGE_BUS_TYPE) As String
   Select Case BusType
          Case BusTypeUnknown: TranslateBusType = "Unknown"
          Case BusTypeScsi:    TranslateBusType = "SCSI"
          Case BusTypeAtapi:   TranslateBusType = "ATAPI"
          Case BusTypeAta:     TranslateBusType = "ATA"
          Case BusType1394:    TranslateBusType = "IEEE_1394"
          Case BusTypeSsa:     TranslateBusType = "SSA"
          Case BusTypeFibre:   TranslateBusType = "FIBRE_CHANNEL"
          Case BusTypeUsb:     TranslateBusType = "USB"
          Case BusTypeRAID:    TranslateBusType = "RAID"
          Case Else:           TranslateBusType = "RESERVED"
   End Select
End Function

Public Function TranslateLoadingMech(ByVal lmType As Byte) As String
   lmType = lmType And &H7
   Select Case lmType
      Case lmCaddy:             TranslateLoadingMech = "Caddy"
      Case lmTray:              TranslateLoadingMech = "Tray"
      Case lmPopup:             TranslateLoadingMech = "Popup"
      Case lmChangerIndividual: TranslateLoadingMech = "Changer (Individula loading)"
      Case lmChangerMagazine:   TranslateLoadingMech = "Changer (Magazine)"
      Case Else:                TranslateLoadingMech = "Unknown"
   End Select
End Function

Public Function TranslateCDSpeed(ByVal speed As Long) As String
   TranslateCDSpeed = CLng(speed / 176) & "x"
End Function

Public Function TranslateReadWriteCapabilities(ByVal cap As Byte) As String
   Dim sCap As String
   If cap & &H1 Then sCap = sCap & "CD_R, "
   If cap & &H2 Then sCap = sCap & "CD_RW, "
   If cap & &H10 Then sCap = sCap & "DVD_R, "
   If cap & &H20 Then sCap = sCap & "DVD_RAM, "
   If cap & &H80 Then sCap = sCap & "DVD_ROM, "
   If cap = "" Then
      TranslateReadWriteCapabilities = "None"
   Else
      TranslateReadWriteCapabilities = Left(sCap, Len(sCap) - 2)
   End If
End Function

Public Function TranslateAdapterAlignmentMask(ByVal mask As Long) As String
   Select Case mask
      Case 0: TranslateAdapterAlignmentMask = "Byte aligned"
      Case 1: TranslateAdapterAlignmentMask = "WORD aligned"
      Case 3: TranslateAdapterAlignmentMask = "DWORD aligned"
      Case 7: TranslateAdapterAlignmentMask = "Double DWORD aligned"
   End Select
End Function

Public Function TranslateMediaType(ByVal MediaType As STORAGE_BUS_TYPE) As String
   Select Case MediaType
      Case DDS_4mm:             TranslateMediaType = "Tape - DAT DDS1,2,... (all vendors)"
      Case MiniQic:             TranslateMediaType = "Tape - miniQIC Tape"
      Case Travan:              TranslateMediaType = "Tape - Travan TR-1,2,3,..."
      Case QIC:                 TranslateMediaType = "Tape - QIC"
      Case MP_8mm:              TranslateMediaType = "Tape - 8mm Exabyte Metal Particle"
      Case AME_8mm:             TranslateMediaType = "Tape - 8mm Exabyte Advanced Metal Evap"
      Case AIT1_8mm:            TranslateMediaType = "Tape - 8mm Sony AIT"
      Case DLT:                 TranslateMediaType = "Tape - DLT Compact IIIxt, IV"
      Case NCTP:                TranslateMediaType = "Tape - Philips NCTP"
      Case IBM_3480:            TranslateMediaType = "Tape - IBM 3480"
      Case IBM_3490E:           TranslateMediaType = "Tape - IBM 3490E"
      Case IBM_Magstar_3590:    TranslateMediaType = "Tape - IBM Magstar 3590"
      Case IBM_Magstar_MP:      TranslateMediaType = "Tape - IBM Magstar MP"
      Case STK_DATA_D3:         TranslateMediaType = "Tape - STK Data D3"
      Case SONY_DTF:            TranslateMediaType = "Tape - Sony DTF"
      Case DV_6mm:              TranslateMediaType = "Tape - 6mm Digital Video"
      Case DMI:                 TranslateMediaType = "Tape - Exabyte DMI and compatibles"
      Case SONY_D2:             TranslateMediaType = "Tape - Sony D2S and D2L"
      Case CLEANER_CARTRIDGE:   TranslateMediaType = "Cleaner - All Drive types that support Drive Cleaners"
      Case CD_ROM:              TranslateMediaType = "Opt_Disk - CD"
      Case CD_R:                TranslateMediaType = "Opt_Disk - CD-Recordable (Write Once)"
      Case CD_RW:               TranslateMediaType = "Opt_Disk - CD-Rewriteable"
      Case DVD_ROM:             TranslateMediaType = "Opt_Disk - DVD-ROM"
      Case DVD_R:               TranslateMediaType = "Opt_Disk - DVD-Recordable (Write Once)"
      Case DVD_RW:              TranslateMediaType = "Opt_Disk - DVD-Rewriteable"
      Case MO_3_RW:             TranslateMediaType = "Opt_Disk - 3.5"" Rewriteable MO Disk"
      Case MO_5_WO:             TranslateMediaType = "Opt_Disk - MO 5.25"" Write Once"
      Case MO_5_RW:             TranslateMediaType = "Opt_Disk - MO 5.25"" Rewriteable (not LIMDOW)"
      Case MO_5_LIMDOW:         TranslateMediaType = "Opt_Disk - MO 5.25"" Rewriteable (LIMDOW)"
      Case PC_5_WO:             TranslateMediaType = "Opt_Disk - Phase Change 5.25"" Write Once Optical"
      Case PC_5_RW:             TranslateMediaType = "Opt_Disk - Phase Change 5.25"" Rewriteable"
      Case PD_5_RW:             TranslateMediaType = "Opt_Disk - PhaseChange Dual Rewriteable"
      Case ABL_5_WO:            TranslateMediaType = "Opt_Disk - Ablative 5.25"" Write Once Optical"
      Case PINNACLE_APEX_5_RW:  TranslateMediaType = "Opt_Disk - Pinnacle Apex 4.6GB Rewriteable Optical"
      Case SONY_12_WO:          TranslateMediaType = "Opt_Disk - Sony 12"" Write Once"
      Case PHILIPS_12_WO:       TranslateMediaType = "Opt_Disk - Philips/LMS 12"" Write Once"
      Case HITACHI_12_WO:       TranslateMediaType = "Opt_Disk - Hitachi 12"" Write Once"
      Case CYGNET_12_WO:        TranslateMediaType = "Opt_Disk - Cygnet/ATG 12"" Write Once"
      Case KODAK_14_WO:         TranslateMediaType = "Opt_Disk - Kodak 14"" Write Once"
      Case MO_NFR_525:          TranslateMediaType = "Opt_Disk - Near Field Recording (Terastor)"
      Case NIKON_12_RW:         TranslateMediaType = "Opt_Disk - Nikon 12"" Rewriteable"
      Case IOMEGA_ZIP:          TranslateMediaType = "Mag_Disk - Iomega Zip"
      Case IOMEGA_JAZ:          TranslateMediaType = "Mag_Disk - Iomega Jaz"
      Case SYQUEST_EZ135:       TranslateMediaType = "Mag_Disk - Syquest EZ135"
      Case SYQUEST_EZFLYER:     TranslateMediaType = "Mag_Disk - Syquest EzFlyer"
      Case SYQUEST_SYJET:       TranslateMediaType = "Mag_Disk - Syquest SyJet"
      Case AVATAR_F2:           TranslateMediaType = "Mag_Disk - 2.5"" Floppy"
      Case MP2_8mm:             TranslateMediaType = "Tape - 8mm Hitachi"
      Case DST_S:               TranslateMediaType = "Ampex DST Small Tapes"
      Case DST_M:               TranslateMediaType = "Ampex DST Medium Tapes"
      Case DST_L:               TranslateMediaType = "Ampex DST Large Tapes"
      Case VXATape_1:           TranslateMediaType = "Ecrix 8mm Tape"
      Case VXATape_2:           TranslateMediaType = "Ecrix 8mm Tape"
      Case STK_9840:            TranslateMediaType = "STK 9840"
      Case LTO_Ultrium:         TranslateMediaType = "IBM, HP, Seagate LTO Ultrium"
      Case LTO_Accelis:         TranslateMediaType = "IBM, HP, Seagate LTO Accelis"
      Case DVD_RAM:             TranslateMediaType = "Opt_Disk - DVD-RAM"
      Case AIT_8mm:             TranslateMediaType = "AIT2 or higher"
      Case ADR_1:               TranslateMediaType = "OnStream ADR Mediatypes"
      Case ADR_2
   End Select
End Function

Public Function TranslateDataType(ByVal DataType As Long) As String
   Select Case DataType
      Case 0:    TranslateDataType = "No media"
      Case 1:    TranslateDataType = "Audio CD"
      Case 2:    TranslateDataType = "Data CD"
      Case Else: TranslateDataType = "Unknown data type"
   End Select
End Function

Public Function TranslateDiskType(ByVal DiskType As Long) As String
   Select Case DataType
      Case 0:       TranslateDiskType = "CD-DA or CD-ROM"
      Case &H10:    TranslateDiskType = "CD-I"
      Case &H20:    TranslateDiskType = "CD-ROM XA"
      Case Else:    TranslateDiskType = "Undefined"
   End Select
End Function

Public Function TranslateDiskStatus(ByVal DiskStatus As Long) As String
   Select Case DiskStatus
      Case 0:    TranslateDiskStatus = "Empty"
      Case 1:    TranslateDiskStatus = "Incomplete"
      Case 2:    TranslateDiskStatus = "Finalized"
      Case Else: TranslateDiskStatus = "Other"
   End Select
End Function

Public Function TranslateSessionStatus(ByVal SessionStatus As Long) As String
   Select Case DiskStatus
      Case 0:    TranslateSessionStatus = "Empty"
      Case 1:    TranslateSessionStatus = "Incomplete"
      Case 2:    TranslateSessionStatus = "Reserve Or Damaged"
      Case 3:    TranslateSessionStatus = "Complete"
      Case Else: TranslateSessionStatus = "Other"
   End Select
End Function

